﻿using OpcLabs.EasyOpc.UA;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TestPbOpcUA
{
    class Program
    {
        static void Main(string[] args)
        {
#if false
            EasyUAClient.SharedParameters.EngineParameters.ApplicationName = "OPCUAConnection";
            EasyUAClient.SharedParameters.EngineParameters.ApplicationUriString = "http://www.mondomaine.com/OPCUAConnection";	// optional
            EasyUAClient.SharedParameters.EngineParameters.ProductUriString = "http://www.mondomaine.com/OPCUAConnection";
#else
            EasyUAClient.SharedParameters.EngineParameters.ApplicationParameters.ApplicationName = "OPCUAConnection";
            EasyUAClient.SharedParameters.EngineParameters.ApplicationParameters.ApplicationUriString = "http://www.mondomaine.com/OPCUAConnection";	// optional
            EasyUAClient.SharedParameters.EngineParameters.ApplicationParameters.ProductUriString = "http://www.mondomaine.com/OPCUAConnection";
#endif
            EasyUAClient client = new EasyUAClient();

            UAEndpointDescriptor endPointDescription = new UAEndpointDescriptor("opc.tcp://localhost:51210/UA/SampleServer");
            endPointDescription.UserIdentity.UserNameTokenInfo.UserName = "pgui";
            endPointDescription.UserIdentity.UserNameTokenInfo.Password = "pguiroot";

            client.DataChangeNotification += Client_DataChangeNotification;

            client.SubscribeDataChange(endPointDescription, "ns=2;i=10849", 100);
            //Thread.Sleep(10);
            client.SubscribeDataChange(endPointDescription, "ns=2;i=10844", 100);


            Thread.Sleep(5000);


            client.DataChangeNotification -= Client_DataChangeNotification;
            client.UnsubscribeAllMonitoredItems();


            //close all unused sessions
            EasyUAClient.CloseAll();

            client.Dispose();
            client = null;


        }

        private static void Client_DataChangeNotification([JetBrains.Annotations.NotNull] object sender, [JetBrains.Annotations.NotNull] OpcLabs.EasyOpc.UA.OperationModel.EasyUADataChangeNotificationEventArgs e)
        {
            Console.WriteLine("Update {0} : {1}", e.Arguments.NodeDescriptor.NodeId, e.Exception ?? e.AttributeData?.Value);
        }
    }
}
